unit Sample1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Blocks, Statsim;

type
  TForm1 = class(TForm)
    Memo: TMemo;
    Button1: TButton;
    MultiRand: TMultiRand;
    Label1: TLabel;
    Entrance: TGenerator;
    Hall: TQueue;
    Barber: TServer;
    ExitDoor: TTerminator;
    Model: TModel;
    procedure Button1Click(Sender: TObject);
    procedure EntranceBeforeTimeGoOn(Sender: TAggregate);
    procedure EntranceExit(Sender: TBlock; Trans: TTransaction);
    procedure EntranceRouting(Sender: TBlock; Trans: TTransaction);
    procedure HallRouting(Sender: TBlock; Trans: TTransaction);
    procedure BarberEnter(Sender: TBlock; Trans: TTransaction);
    procedure BarberRouting(Sender: TBlock; Trans: TTransaction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   Model.Simulate(280.0);

   Memo.Lines.Add('Usage of the barber: '+FormatFloat('0.00',Barber.Usage));
   Memo.Lines.Add('Average queue length: '+FormatFloat('0.00',Hall.AverageCount));
   Memo.Lines.Add('Maximal queue length: '+IntToStr(Hall.MaxCount));
   Memo.Lines.Add('Average waiting time: '+FormatFloat('0.00',Hall.AverageTime));
   Memo.Lines.Add('Deviation of waiting time: '+FormatFloat('0.00',Hall.DeviationTime));
   Memo.Lines.Add('Average waiting time / excluding zero times: '+FormatFloat('0.00',Hall.SAverageTime));
   Memo.Lines.Add('Deviation of waiting time/ excluding zero times: '+FormatFloat('0.00',Hall.SDeviationTime));

   Model.Reset;
end;


procedure TForm1.EntranceBeforeTimeGoOn(Sender: TAggregate);
begin
  Sender.NextTime(0.0);
end;

procedure TForm1.EntranceExit(Sender: TBlock; Trans: TTransaction);
begin
  Sender.NextTime(MultiRand.Uniform(12.0,24.0));
end;

procedure TForm1.EntranceRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(Hall);
end;

procedure TForm1.HallRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(Barber);
end;

procedure TForm1.BarberEnter(Sender: TBlock; Trans: TTransaction);
begin
  Sender.NextTime(MultiRand.Uniform(14.0,20.0));
end;

procedure TForm1.BarberRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(ExitDoor);
end;

end.
