unit Sample13;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Blocks, Statsim, ComCtrls;

type
  TForm1 = class(TForm)
    Memo: TMemo;
    Button1: TButton;
    MultiRand: TMultiRand;
    Label1: TLabel;
    ProgressBar: TProgressBar;
    EditSim: TEdit;
    Label3: TLabel;
    EditProcLower: TEdit;
    Label4: TLabel;
    EditArrLower: TEdit;
    Label2: TLabel;
    EditArrUpper: TEdit;
    Label5: TLabel;
    EditProcUpper: TEdit;
    Tabulator1: TTabulator;
    BoxArrival: TGenerator;
    BoxQueue: TQueue;
    BoxToDetails: TDivider;
    Tool: TServer;
    DetailsToBox: TAssembler;
    AnotherWorkShop: TTerminator;
    Model: TModel;
    procedure Button1Click(Sender: TObject);
    procedure EditSimExit(Sender: TObject);
    procedure EditArrLowerExit(Sender: TObject);
    procedure EditProcLowerExit(Sender: TObject);
    procedure EditArrUpperExit(Sender: TObject);
    procedure EditProcUpperExit(Sender: TObject);
    procedure BoxArrivalBeforeTimeGoOn(Sender: TAggregate);
    procedure BoxArrivalExit(Sender: TBlock; Trans: TTransaction);
    procedure BoxArrivalRouting(Sender: TBlock; Trans: TTransaction);
    procedure BoxQueueRouting(Sender: TBlock; Trans: TTransaction);
    procedure BoxToDetailsRouting(Sender: TBlock; Trans: TTransaction);
    procedure ToolEnter(Sender: TBlock; Trans: TTransaction);
    procedure ToolRouting(Sender: TBlock; Trans: TTransaction);
    procedure DetailsToBoxRouting(Sender: TBlock; Trans: TTransaction);
    procedure ModelNewTime(Sender: TAggregate; Trans: TTransaction);
    procedure AnotherWorkShopEnter(Sender: TBlock; Trans: TTransaction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



var
  Form1: TForm1;
  LimitTime: real;           // Simulation time
  ArrLowerTime: real;        // Lower bound of arrival time
  ArrUpperTime: real;        // Upper bounnd of arrivval time
  ProcLowerTime: real;       // Lower bound of processing time
  ProcUpperTime: real;       // Upper bound of processing time
  LastArriveTime: real;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var i: integer;
begin

   try
      ArrLowerTime:=StrToFloat(Trim(EditArrLower.Text));
   except
      MessageDlg('Invalid lower bound of arrival time',mtError,[mbOK],0);
      EditArrLower.SetFocus;
      Exit;
   end;
   if ArrLowerTime<0.0 then
   begin
      MessageDlg('Invalid lower bound of arrival time',mtError,[mbOK],0);
      EditArrLower.SetFocus;
      Exit;
   end;

   try
      ArrUpperTime:=StrToFloat(Trim(EditArrUpper.Text));
   except
      MessageDlg('Invalid upper bound of arrival time',mtError,[mbOK],0);
      EditArrUpper.SetFocus;
      Exit;
   end;
   if ArrUpperTime<=0.0 then
   begin
      MessageDlg('Invalid upper bound of arrival time',mtError,[mbOK],0);
      EditArrUpper.SetFocus;
      Exit;
   end;

   if ArrUpperTime<ArrLowerTime then
   begin
      MessageDlg('Invalid arrival range',mtError,[mbOK],0);
      EditArrLower.SetFocus;
      Exit;
   end;

   try
      ProcLowerTime:=StrToFloat(Trim(EditProcLower.Text));
   except
      MessageDlg('Invalid lower bound of processing time',mtError,[mbOK],0);
      EditProcLower.SetFocus;
      Exit;
   end;
   if ProcLowerTime<=0.0 then
   begin
      MessageDlg('Invalid lower bound of processing time',mtError,[mbOK],0);
      EditProcLower.SetFocus;
      Exit;
   end;

   try
      ProcUpperTime:=StrToFloat(Trim(EditProcUpper.Text));
   except
      MessageDlg('Invalid upper bound of processing time',mtError,[mbOK],0);
      EditProcUpper.SetFocus;
      Exit;
   end;
   if ProcUpperTime<=0.0 then
   begin
      MessageDlg('Invalid upper bound of processing time',mtError,[mbOK],0);
      EditProcUpper.SetFocus;
      Exit;
   end;

   if ProcUpperTime<ProcLowerTime then
   begin
      MessageDlg('Invalid processing range',mtError,[mbOK],0);
      EditProcLower.SetFocus;
      Exit;
   end;

   try
      LimitTime:=StrToFloat(Trim(EditSim.Text));
   except
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;
   if LimitTime<=0.0 then
   begin
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;

   Memo.Lines.Clear;
   LastArriveTime:=0.0;
   Model.Simulate(LimitTime);
   with Tabulator1 do
   begin
      Memo.Lines.Add('The histogram of box department interval');
      Memo.Lines.Add('Below '+FormatFloat('000.00',LowerBound)+':     '+
                     IntToStr(Hits(0)));
      for i:=1 to Tabulator1.IntervalCount do
      begin
         Memo.Lines.Add(FormatFloat('000.00',LowerBound+Interval*(i-1))+' - '+
                        FormatFloat('000.00',LowerBound+Interval*(i))+'   '+
                        IntToStr(Hits(i)));
      end;
      Memo.Lines.Add('Upper '+FormatFloat('000.00',LowerBound+
                     Interval*IntervalCount)+':     '+
                     IntToStr(Hits(IntervalCount+1)));
      Memo.Lines.Add('________________________________________');
      Memo.Lines.Add('Average output interval '+
                     FormatFloat('0.00',Tabulator1.Mean));
      Memo.Lines.Add('Deviation of output interval: '+
                     FormatFloat('0.00',Tabulator1.Deviation));
   end;
   Model.Reset;
end;






procedure TForm1.EditArrLowerExit(Sender: TObject);
begin
   try
      ArrLowerTime:=StrToFloat(Trim(EditArrLower.Text));
   except
      MessageDlg('Invalid lower bound of arrival time',mtError,[mbOK],0);
      EditArrLower.SetFocus;
      Exit;
   end;
   if ArrLowerTime<0.0 then
   begin
      MessageDlg('Invalid lower bound of arrival time',mtError,[mbOK],0);
      EditArrLower.SetFocus;
   end;
end;

procedure TForm1.EditArrUpperExit(Sender: TObject);
begin
   try
      ArrUpperTime:=StrToFloat(Trim(EditArrUpper.Text));
   except
      MessageDlg('Invalid upper bound of arrival time',mtError,[mbOK],0);
      EditArrUpper.SetFocus;
      Exit;
   end;
   if ArrUpperTime<=0.0 then
   begin
      MessageDlg('Invalid upper bound of arrival time',mtError,[mbOK],0);
      EditArrUpper.SetFocus;
   end;
end;


procedure TForm1.EditProcLowerExit(Sender: TObject);
begin
   try
      ProcLowerTime:=StrToFloat(Trim(EditProcLower.Text));
   except
      MessageDlg('Invalid lower bound of processing time',mtError,[mbOK],0);
      EditProcLower.SetFocus;
      Exit;
   end;
   if ProcLowerTime<=0.0 then
   begin
      MessageDlg('Invalid lower bound of processing time',mtError,[mbOK],0);
      EditProcLower.SetFocus;
   end;
end;


procedure TForm1.EditProcUpperExit(Sender: TObject);
begin
   try
      ProcUpperTime:=StrToFloat(Trim(EditProcUpper.Text));
   except
      MessageDlg('Invalid upper bound of processing time',mtError,[mbOK],0);
      EditProcUpper.SetFocus;
      Exit;
   end;
   if ProcUpperTime<=0.0 then
   begin
      MessageDlg('Invalid upper bound of processing time',mtError,[mbOK],0);
      EditProcUpper.SetFocus;
   end;
end;

procedure TForm1.EditSimExit(Sender: TObject);
begin
   try
      LimitTime:=StrToFloat(Trim(EditSim.Text));
   except
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;
   if LimitTime<=0.0 then
   begin
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
   end;
end;

procedure TForm1.BoxArrivalBeforeTimeGoOn(Sender: TAggregate);
begin
  Sender.NextTime(0.0);
end;

procedure TForm1.BoxArrivalExit(Sender: TBlock; Trans: TTransaction);
begin
  Sender.NextTime(MultiRand.Uniform(ArrLowerTime,ArrUpperTime));
end;

procedure TForm1.BoxArrivalRouting(Sender: TBlock; Trans: TTransaction);
begin
   Sender.PassTo(BoxQueue);
end;

procedure TForm1.BoxQueueRouting(Sender: TBlock; Trans: TTransaction);
begin
   Sender.PassTo(BoxToDetails);
end;

procedure TForm1.BoxToDetailsRouting(Sender: TBlock; Trans: TTransaction);
begin
   Sender.PassTo(Tool);
end;

procedure TForm1.ToolEnter(Sender: TBlock; Trans: TTransaction);
begin
  Sender.NextTime(MultiRand.Uniform(ProcLowerTime,ProcUpperTime));
end;

procedure TForm1.ToolRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(DetailsToBox);
end;

procedure TForm1.DetailsToBoxRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(AnotherWorkShop);
end;


procedure TForm1.ModelNewTime(Sender: TAggregate; Trans: TTransaction);
var  NewPos: integer;
     Ratio: real;
begin
   Ratio:=ModelTime/LimitTime;
   if Ratio>1.0 then Ratio:=1.0;
   NewPos:=Round(Ratio*100.0);
   with ProgressBar do
      if Position<>NewPos then Position:=NewPos;
end;


procedure TForm1.AnotherWorkShopEnter(Sender: TBlock; Trans: TTransaction);
begin
  Tabulator1.PutValue(ModelTime-LastArriveTime);
  LastArriveTime:=ModelTime;
end;

end.
