unit Sample19;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Blocks, Statsim, ComCtrls;

type
  TForm1 = class(TForm)
    Memo: TMemo;
    Button1: TButton;
    MultiRand: TMultiRand;
    Label1: TLabel;
    ProgressBar: TProgressBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditArrive: TEdit;
    EditServ: TEdit;
    EditSim: TEdit;
    Model: TModel;
    procedure Button1Click(Sender: TObject);
    procedure EditArriveExit(Sender: TObject);
    procedure EditServExit(Sender: TObject);
    procedure EditSimExit(Sender: TObject);
    procedure ModelNewTime(Sender: TAggregate; Trans: TTransaction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



var
  Form1: TForm1;
  ArrivalTime: real;    // Average arrival time
  ServiceTime: real;    // Average service time
  SimTime: real;        // Simulation time


implementation

{$R *.DFM}

Uses Unit2,Unit3;

procedure TForm1.Button1Click(Sender: TObject);
begin
   { Checking all input paramters }
   try
      ArrivalTime:=StrToFloat(Trim(EditArrive.Text));
   except
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;
   if ArrivalTime<=0.0 then
   begin
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;

   try
      ServiceTime:=StrToFloat(Trim(EditServ.Text));
   except
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;
   if ServiceTime<=0.0 then
   begin
      MessageDlg('',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;

   try
      SimTime:=StrToFloat(Trim(EditSim.Text));
   except
      MessageDlg('Invalid simulatin time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;
   if SimTime<=0.0 then
   begin
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;

   Model.Simulate(SimTime);
   Memo.Lines.Add('Usage of the barber: '+FormatFloat('0.00',Form3.Barber.Usage));
   Memo.Lines.Add('Average queue length: '+FormatFloat('0.00',Form2.Hall.AverageCount));
   Memo.Lines.Add('Maximal queue length: '+IntToStr(Form2.Hall.MaxCount));
   Memo.Lines.Add('Average waiting time: '+FormatFloat('0.00',Form2.Hall.AverageTime));
   Memo.Lines.Add('Deviation of waiting time: '+FormatFloat('0.00',Form2.Hall.DeviationTime));
   Memo.Lines.Add('Average waiting time / excluding zero times: '+FormatFloat('0.00',Form2.Hall.SAverageTime));
   Memo.Lines.Add('Deviation of waiting time/ excluding zero times: '+FormatFloat('0.00',Form2.Hall.SDeviationTime));
   Model.Reset;
   MultiRand.Reset;
end;

procedure TForm1.EditArriveExit(Sender: TObject);
begin
   try
      ArrivalTime:=StrToFloat(Trim(EditArrive.Text));
   except
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;
   if ArrivalTime<=0.0 then
   begin
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
   end;
end;

procedure TForm1.EditServExit(Sender: TObject);
begin
   try
      ServiceTime:=StrToFloat(Trim(EditServ.Text));
   except
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;
   if ServiceTime<=0.0 then
   begin
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ.SetFocus;
   end;

end;

procedure TForm1.EditSimExit(Sender: TObject);
begin
   try
      SimTime:=StrToFloat(Trim(EditSim.Text));
   except
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;
   if SimTime<=0.0 then
   begin
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditServ.SetFocus;
   end;
end;

procedure TForm1.ModelNewTime(Sender: TAggregate; Trans: TTransaction);
var  NewPos: integer;
     Ratio: real;
begin
   Ratio:=ModelTime/SimTime;
   if Ratio>1.0 then Ratio:=1.0;
   NewPos:=Round(Ratio*100.0);
   with ProgressBar do
      if Position<>NewPos then Position:=NewPos;
end;

end.
